summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Ebben Aries2021-01-02 00:59:21 +0100
committer Willy Sudiarto Raharjo2021-01-02 04:48:27 +0100
commita4d0c91859d037090effb0c11b3873ef1b6e4a1b (patch)
treeb7c379bca9d7ae2d2d108ec8c3a56d004958d1f3
parent5fb3b0a24caf4472cbcc8d027dfea6c3c9ad875f (diff)
downloadslackbuilds-a4d0c91859d037090effb0c11b3873ef1b6e4a1b.tar.gz
system/prometheus: Added (Open-Source Monitoring & Alerting Toolkit)
Signed-off-by: Dave Woodfall <dave@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--system/prometheus/README24
-rw-r--r--system/prometheus/doinst.sh26
-rw-r--r--system/prometheus/prometheus.SlackBuild106
-rw-r--r--system/prometheus/prometheus.info10
-rw-r--r--system/prometheus/rc.prometheus.new65
-rw-r--r--system/prometheus/slack-desc19
6 files changed, 250 insertions, 0 deletions
diff --git a/system/prometheus/README b/system/prometheus/README
new file mode 100644
index 0000000000..32872f5f9c
--- /dev/null
+++ b/system/prometheus/README
@@ -0,0 +1,24 @@
+Prometheus (An Open-Source Monitoring and Alerting Toolkit)
+
+Prometheus is an open-source systems monitoring and alerting toolkit
+originally built at SoundCloud.
+
+Prometheus's main features are:
+
+- a multi-dimensional data model with time series data identified by
+ metric name and key/value pairs
+- PromQL, a flexible query language to leverage this dimensionality
+- no reliance on distributed storage; single server nodes are autonomous
+- time series collection happens via a pull model over HTTP
+- pushing time series is supported via an intermediary gateway
+- targets are discovered via service discovery or static configuration
+- multiple modes of graphing and dashboarding support
+
+Groupname and Username
+
+You must have the "prometheus" group and user to run this script, for
+example:
+
+ groupadd -g 368 prometheus
+ useradd -u 368 -s /bin/false -d /var/lib/prometheus \
+ -g prometheus prometheus
diff --git a/system/prometheus/doinst.sh b/system/prometheus/doinst.sh
new file mode 100644
index 0000000000..5e73a492a1
--- /dev/null
+++ b/system/prometheus/doinst.sh
@@ -0,0 +1,26 @@
+config() {
+ NEW="$1"
+ OLD="`dirname $NEW`/`basename $NEW .new`"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "`cat $OLD | md5sum`" = "`cat $NEW | md5sum`" ]; then # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+config etc/prometheus/prometheus.yml.new
+
+preserve_perms etc/rc.d/rc.prometheus.new
diff --git a/system/prometheus/prometheus.SlackBuild b/system/prometheus/prometheus.SlackBuild
new file mode 100644
index 0000000000..a7a9df10aa
--- /dev/null
+++ b/system/prometheus/prometheus.SlackBuild
@@ -0,0 +1,106 @@
+#!/bin/sh
+
+# Slackware build script for Prometheus
+
+# Copyright 2017-2020 Ebben Aries <slackbuilds@dscp.org>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=prometheus
+VERSION=${VERSION:-2.23.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+UIDGID=368
+if ! getent group $PRGNAM; then
+ echo " You must have the \"$PRGNAM\" group to run this script."
+ echo " # groupadd -g $UIDGID $PRGNAM"
+ exit 1
+elif ! getent passwd $PRGNAM; then
+ echo " You must have the \"$PRGNAM\" user to run this script."
+ echo " # useradd -u $UIDGID -s /bin/false -d /var/lib/$PRGNAM -g $PRGNAM $PRGNAM"
+ exit 1
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "x86_64" ]; then
+ PKG_ARCH=amd64
+else
+ echo "$ARCH is not supported."
+ exit 1
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM
+tar xvf $CWD/$PRGNAM-${VERSION}.linux-${PKG_ARCH}.tar.gz
+cd $PRGNAM-${VERSION}.linux-${PKG_ARCH}
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p $PKG/etc/prometheus
+cp -a prometheus.yml $PKG/etc/prometheus/prometheus.yml.new
+
+mkdir -p $PKG/usr/bin
+cp -a prometheus $PKG/usr/bin
+cp -a promtool $PKG/usr/bin
+
+mkdir -p $PKG/usr/share/prometheus
+cp -ar console_libraries $PKG/usr/share/prometheus
+cp -ar consoles $PKG/usr/share/prometheus
+
+mkdir -p $PKG/var/lib/prometheus
+chown -R prometheus:prometheus $PKG/var/lib/prometheus
+
+mkdir -p $PKG/etc/rc.d
+cat $CWD/rc.prometheus.new > $PKG/etc/rc.d/rc.prometheus.new
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENSE NOTICE $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/prometheus/prometheus.info b/system/prometheus/prometheus.info
new file mode 100644
index 0000000000..ab7e539f29
--- /dev/null
+++ b/system/prometheus/prometheus.info
@@ -0,0 +1,10 @@
+PRGNAM="prometheus"
+VERSION="2.23.0"
+HOMEPAGE="https://prometheus.io"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://github.com/prometheus/prometheus/releases/download/v2.23.0/prometheus-2.23.0.linux-amd64.tar.gz"
+MD5SUM_x86_64="dc61f5800c01ba09f501546c61952096"
+REQUIRES=""
+MAINTAINER="Ebben Aries"
+EMAIL="slackbuilds@dscp.org"
diff --git a/system/prometheus/rc.prometheus.new b/system/prometheus/rc.prometheus.new
new file mode 100644
index 0000000000..6d1e705e0e
--- /dev/null
+++ b/system/prometheus/rc.prometheus.new
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+# Copyright 2020, Ebben Aries, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PROG=/usr/bin/prometheus
+USER=prometheus
+LOGFILE=/var/log/prometheus.log
+CONF=/etc/prometheus/prometheus.yml
+TSDB=/var/lib/prometheus
+WEB_LIBS=/usr/share/prometheus/console_libraries
+WEB_TEMPLATES=/usr/share/prometheus/consoles
+
+prometheus_start() {
+ echo -e "Starting Prometheus..."
+ nohup sudo -u $USER $PROG \
+ --config.file=$CONF \
+ --storage.tsdb.path=$TSDB \
+ --web.console.libraries=$WEB_LIBS \
+ --web.console.templates=$WEB_TEMPLATES \
+ > $LOGFILE 2>&1 &
+}
+
+prometheus_stop() {
+ echo -e "Stopping Prometheus..."
+ killall prometheus
+}
+
+prometheus_restart() {
+ prometheus_stop
+ sleep 3
+ prometheus_start
+}
+
+case "$1" in
+ start)
+ prometheus_start
+ ;;
+ stop)
+ prometheus_stop
+ ;;
+ restart)
+ prometheus_restart
+ ;;
+ *)
+ echo "Usage: $0 {start|stop|restart}"
+ exit 1
+esac
diff --git a/system/prometheus/slack-desc b/system/prometheus/slack-desc
new file mode 100644
index 0000000000..30bd4f1c35
--- /dev/null
+++ b/system/prometheus/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+prometheus: Prometheus (An Open-Source Monitoring and Alerting Toolkit)
+prometheus:
+prometheus: Prometheus is an open-source systems monitoring and alerting toolkit
+prometheus: originally built at SoundCloud.
+prometheus:
+prometheus:
+prometheus:
+prometheus:
+prometheus:
+prometheus: Home-Page: https://prometheus.io
+prometheus: